/******************/
/* D88 to binary  */
/******************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXTRACK	164
#define	MAX_N		6

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		a0,a1,a2,a3;

	long int	filelen;
	long int	f_start[MAXTRACK];
	long int	fp;
	long int	trackend;

	int		st_tr,ed_tr;
	int		st_sc,ed_sc;
	int		fileno;
	int		secno,secnum;
	int		c,i;

	static int	seclen[MAX_N] = {
		128,256,512,1024,2048,4096
	};

	if (argc != 7) {
		fprintf(stderr, "Usage: disk2track infile outfile start-track start-sector end-track end-sector\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	st_tr = atoi(argv[3]);
	st_sc = atoi(argv[4]);
	ed_tr = atoi(argv[5]);
	ed_sc = atoi(argv[6]);

	if (st_tr < 0 || st_tr >= MAXTRACK) {
		printf("start track no. illigal \n");
		exit(1);
	}

	if (ed_tr < st_tr || ed_tr >= MAXTRACK) {
		printf("end track no. illigal \n");
		exit(1);
	}

	if (st_sc < 1 || st_sc >= 17) {
		printf("start sector no. illigal \n");
		exit(1);
	}

	if (ed_sc < 1 || ed_sc >= 17) {
		printf("end sector no. illigal \n");
		exit(1);
	}

	fseek(infp,0x1c,SEEK_SET);

/* t@Cǂݍ */
	a0 = fgetc(infp);
	a1 = fgetc(infp);
	a2 = fgetc(infp);
	a3 = fgetc(infp);

	filelen = a3*0x1000000+a2*0x10000+a1*0x100+a0;

/* gbN̐擪ʒuǂݍ */
	for (i = 0;i < MAXTRACK;i ++) {
		a0 = fgetc(infp);
		a1 = fgetc(infp);
		a2 = fgetc(infp);
		a3 = fgetc(infp);
		f_start[i] = a3*0x1000000+a2*0x10000+a1*0x100+a0;
	}

	f_start[i] = filelen;


	for (fileno = st_tr;fileno <= ed_tr;fileno ++) {

/* |C^OȂ΂̃gbN݂͑ */
		if (f_start[fileno] == 0L) {
			printf("Error!\n");
			printf("Track no.%d not found\n",fileno);
			exit(1);
		}

		fseek(infp,f_start[fileno],SEEK_SET);

		a0 = fgetc(infp);
		a0 = fgetc(infp);
		a0 = fgetc(infp);
		a0 = fgetc(infp);
		secnum = fgetc(infp);	/* ̃gbÑZN^ */

		fseek(infp,f_start[fileno],SEEK_SET);

		for (secno = 0;secno < secnum;secno ++) {

			a0 = fgetc(infp);
			a1 = fgetc(infp);
			a2 = fgetc(infp);
			a3 = fgetc(infp);

			if (a3 != 0x01) {
				printf("Error!\n");
				printf("N is illigal CHRN=%02x:%02x:%02x:%02x\n",a0,a1,a2,a3);
				exit(1);
			}

			for (i = 0;i < 12;i ++) {
				a0 = fgetc(infp);
			}

			for (i = 0;i < seclen[a3];i ++) {
				if ( (c = fgetc(infp)) == EOF) {
					printf("Error!\n");
					printf("File length illigal CHRN=%02x:%02x:%02x:%02x\n",a0,a1,a2,a3);
					exit(1);
				}

				if (fileno == st_tr) {
					if (fileno == ed_tr) {
						if (secno+1 <= ed_sc) {
							fputc(c,outfp);
						}
					} else if (secno+1 >= st_sc) {
						fputc(c,outfp);
					}
				} else if (fileno == ed_tr) {
					if (secno+1 <= ed_sc) {
						fputc(c,outfp);
					}
				} else {
					fputc(c,outfp);
				}

			}

		}


	}

	fclose(outfp);
	fclose(infp);


	return(0);
}
